#ifndef __COMMAND_H
#define __COMMAND_H

typedef void (*GnapsterCommand) (char *command, char *args);

#define GNAPSTER_COMMAND(x) void x (char *command, char *args)

typedef struct _command {
   char *command;
   GnapsterCommand func;
   char *syntax;
   char *help;
} COMMAND;

void invalid_args(char *);
int handle_command(char *, char *);
GNAPSTER_COMMAND(do_sendtext);
GNAPSTER_COMMAND(do_help);
GNAPSTER_COMMAND(do_version);
GNAPSTER_COMMAND(do_wallop);
GNAPSTER_COMMAND(do_topic);
GNAPSTER_COMMAND(do_clear);
GNAPSTER_COMMAND(do_sv);
GNAPSTER_COMMAND(do_whois);
GNAPSTER_COMMAND(do_msg);
GNAPSTER_COMMAND(do_me);
GNAPSTER_COMMAND(do_query);
GNAPSTER_COMMAND(do_ignore);
GNAPSTER_COMMAND(do_unignore);
GNAPSTER_COMMAND(do_join);
GNAPSTER_COMMAND(do_part);
GNAPSTER_COMMAND(do_raw);
GNAPSTER_COMMAND(do_kill);
GNAPSTER_COMMAND(do_ban);
GNAPSTER_COMMAND(do_unban);
GNAPSTER_COMMAND(do_muzzle);
GNAPSTER_COMMAND(do_unmuzzle);
GNAPSTER_COMMAND(do_setport);
GNAPSTER_COMMAND(do_userlevel);
GNAPSTER_COMMAND(do_links);
GNAPSTER_COMMAND(do_signore);
GNAPSTER_COMMAND(do_unsignore);
GNAPSTER_COMMAND(do_sigsave);
GNAPSTER_COMMAND(do_share);

#endif /* __COMMAND_H */
