#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <ctype.h>

#include <gnome.h>

#include "napster.h"
#include "gnapster.h"
#include "callbacks.h"
#include "ui.h"
#include "upload.h"
#include "network.h"
#include "commands.h"
#include "download.h"

#include "queue.h"

#include "config.h"

extern CONN_INFO conn_info;
extern DOWNLOAD_TAB download_tab;
extern USER_INFO user_info;

int remote_queue_check(void *data) {
   NAP_DOWNLOAD *download;
   
   if (!data)
     return 0;
   
   download = (NAP_DOWNLOAD *)data;
   
   napster_send(conn_info.sock, NAPSTER_GET, "%s \"%s\"",
		download->user, download->file);
   
   return 0;
}

void queue_check() {
   int downloads, queue;
   NAP_DOWNLOAD *q, *dup;
   
   queue = g_list_length(GTK_CLIST(download_tab.queue_clist)->row_list);
   if (!queue)
     return;
   
   downloads = g_list_length(GTK_CLIST(download_tab.clist)->row_list);
   if (downloads >= user_info.conf[MAX_DOWNLOADS])
     return;
   
   q = gtk_clist_get_row_data(GTK_CLIST(download_tab.queue_clist), 0);
   if (!q)
     return;
   
   dup = download_dup(q);
   handle_download(dup, DOWNLOAD_NORMAL);

   gtk_clist_remove(GTK_CLIST(download_tab.queue_clist), 0);
}

void add_queue(NAP_DOWNLOAD *data) {
   if (!data)
     return;
   
   gnapster_clist_append(download_tab.queue_clist, download_tab.vbox, data,
			 data->trunc_file, data->user, NULL);
}

void cancel_queue_cb() {
   NAP_DOWNLOAD *temp;
   GtkWidget *clist = (GtkWidget *)download_tab.queue_clist;
   GList *selection, *selptr = NULL;

   selection = GTK_CLIST(clist)->selection;
   if (!selection)
     return;

   while(selection) {
      temp = gtk_clist_get_row_data(GTK_CLIST(clist), (int)selection->data);
      if (temp)
	selptr = g_list_append(selptr, temp);

      selection = selection->next;
   }

   selection = selptr;
   while(selection) {
      temp = selection->data;
      gtk_clist_remove(GTK_CLIST(clist),
		       gtk_clist_find_row_from_data(GTK_CLIST(clist), temp));
      selection = selection->next;
   }
}

void force_queue_cb(GtkWidget *w, gpointer data) {
   download_true_cb(download_tab.queue_clist, data);
}
