#ifndef __UPLOAD_H
#define __UPLOAD_H

#define SUBMIT_LIST 0
#define UPDATE_LIST 1
#define BUILD_LIST 2

typedef struct _header {
   int idex;
   int id;
   int layer;
   int protection_bit;
   int bitrate_index;
   int freq;
   int padding_bit;
   int private_bit;
   int mode;
   int mode_extension;
   int copyright;
   int original;
   int emphasis;
   int stereo;
   int jsbound;
   int sblimit;
   int true_layer;
   int framesize;
} HEADER;

typedef struct _mp3 {
   char *filename;
   char *checksum;
   unsigned long filesize;
   time_t time;
   int bitrate;
   int freq;
   int stereo;
   int type;
   time_t mtime;
} MP3;

typedef struct _file_entry {
   time_t mtime;
   char *file;
} FILE_ENTRY;

int _get_input(int, unsigned char *, int);
int get_header(int, HEADER *);
long get_bitrate(int, time_t *, int *, unsigned long *, int *, long *, int *, time_t *);
char *get_checksum(int, unsigned long);
char *conv_win(char *);
char *conv_unix(char *);
GList *list_match(GList *, char *);
void build_pipe_stop(int);
void build_pipe_read(gpointer, int, GdkInputCondition);
void setup_build_dlg(FILE *, char *, int, GList *);
void remove_slash(char *);
FILE *open_shared(int);
int shared_list_handle(char *, int);

#endif /* __UPLOAD_H */
